#!/usr/bin/env python2
# -*- coding: latin-1 -*-
#it works even if it loses track sometimes (returns to Home)
import QboCmd
import serial
import cv2
import numpy
import time
#import sys

# constant for the movement
#Kpx = 1
#Kpy = 1
Ksp = 100 #speed = 100

#step controls not used
#Step_x = ([2, 5, 10])
#Step_y = ([1, 3, 7])

#freme dimension
fw = 320
fh = 280
fwc = fw/2
fhc =fh/2
#center face coordinate
xc = 0
yc = 0
delta_x = 0
delta_y = 0

## Head X and Y angle limits
Xmax = 725
Xmin = 290
Ymax = 550
Ymin = 400

## Initial Head position
Home_x = 511
Home_y = 420

# logic flag
Facedet = None
#--------------------
port = '/dev/serial0'
# Open serial port
ser = serial.Serial(port, baudrate=115200, bytesize = serial.EIGHTBITS, stopbits = serial.STOPBITS_ONE, parity = serial.PARITY_NONE, rtscts = False, dsrdtr =False, timeout = 0)
print "Open serial port sucessfully."
print(ser.name)
QBO = QboCmd.Controller(ser)
#---------------------------
print("Blue Nose")
QBO.SetNoseColor(1) 
time.sleep(1)
#print("Right Positon")
##Move the head to the right
#QBO.SetServo(1,290, 250)#Axis,Angle,Speed
##pause
#time.sleep(1)
#print("Left position")
#Move the head to the left
#QBO.SetServo(1,720, 250)#Axis,Angle,Speed
#Pause
time.sleep(1)
#print("Center head")
#QBO.SetServo(1,500, 100)#Axis,Angle,Speed
##Pause
time.sleep(1)
print("Up Position")
QBO.SetServo(2,450,100)#Axis,Angle,Speed
time.sleep(3)
#settings
ir = 0
detected = ''
no_move_tm = time.time()
reg_tm =time.time()
# information on the page https://github.com/opencv/opencv/tree/master/data/haarcascades
cascPath = "haarcascade_frontalface_alt2.xml"
faceCascade = cv2.CascadeClassifier(cascPath)
i = 0
counter = 0
video_capture = cv2.VideoCapture(0)
video_capture.set(cv2.cv.CV_CAP_PROP_FRAME_WIDTH, fw)  
video_capture.set(cv2.cv.CV_CAP_PROP_FRAME_HEIGHT, fh)
#---------------

def ServoHome():
	global Home_x, Home_y, Xcoor, Ycoor, reg_tm
        
	Home_x = 511
	Home_y = 550
	QBO.SetServo(1, Home_x, 100)
	QBO.SetServo(2, Home_y, 100)
	#reg_tm = time.time()

	return
def CamLeft():  # To move left, we are provided a distance to move and a speed to move.
	global Home_x,Xcoor, delta_x, Xmin, Ksp, reg_tm
	
	Xcoor = Home_x + delta_x/2
	print("CamLeft ",Xcoor, " delta_x ",delta_x)
	#Xcoor = Xcoor - Kpx * distance
	if Xcoor < Xmin:
	    Xcoor = Xmin
	
	QBO.SetServo(1, Xcoor,Ksp)
	#time.sleep(0.1)
	#reg_tm = time.time()

	return

def CamRight():  # Same logic as above
	global Home_x, Xcoor, delta_x, Xmax, Ksp, reg_tm
	Xcoor = Home_y + delta_x/2
	print("CamRight ",Xcoor, " delta_x ",delta_x)   
	
	if Xcoor > Xmax:
	    Xcoor = Xmax
	QBO.SetServo(1, Xcoor, Ksp)
	#time.sleep(0.1)
	#reg_tm = time.time()

	return

def CamDown():  # Same logic as above
	global Home_y, Ycoor, Ymax, Ksp, reg_tm
	Ycoor = Home_y - delta_y
        print("CamDown ",Ycoor, " delta_y ",delta_y) 
	if Ycoor > Ymax:
	    Ycoor = Ymax
	QBO.SetServo(2, Ycoor, Ksp)
	#time.sleep(0.1)
	#reg_tm = time.time()

	return

def CamUp():  # Same logic as above
	global Home_y, Ycoor, Ymin, Ksp, reg_tm
	Ycoor = Home_y - delta_y
        print("CamUp ", Ycoor, " delta_y ",delta_y) 
	if Ycoor < Ymin:
		Ycoor = Ymin
	QBO.SetServo(2, Ycoor, Ksp)
	#time.sleep(0.1)
	#reg_tm = time.time()

	return
# default initial position ... then it will move with the mic sensors
ServoHome() 

while True:
    
    i+=1
    #print("i",i)
    # Capture frame-by-frame
    ret, frame = video_capture.read()
    gray = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)
    cv2.imwrite('/home/pi/QBO/QBO_Test/img_gray.jpg',gray)
    faces = faceCascade.detectMultiScale(
        gray,
        scaleFactor=1.03,
        minNeighbors=1,
        minSize=(80, 80),
        flags=cv2.cv.CV_HAAR_SCALE_IMAGE
    )
    #print ("FACES",faces)
    # Draw a rectangle around the faces
    for (x, y, w, h) in faces:
        xc=x+w/2
        yc=y+h/2
        delta_x = fwc - xc
        delta_y = fhc - yc
        cv2.rectangle(frame, (x, y), (x+w, y+h), (0, 255, 0), 2)
        
    # Display the resulting frame
    if faces != ():
        facedet = True
        counter+=1
	ir = 0
        #print ("center x", xc, " center y",yc)
        cv2.putText(frame, "Cont: {}".format(counter), (10, 20),
			cv2.FONT_HERSHEY_SIMPLEX, 0.5, (0, 0, 255), 2)
        #----------
        cv2.circle(frame, (xc,yc), radius=1, color=(0, 0, 255), thickness=-1)
        cv2.putText(frame, "x: {}".format(xc), (10, 40),
			cv2.FONT_HERSHEY_SIMPLEX, 0.5, (0, 0, 255), 2)
        cv2.putText(frame, "v: {}".format(yc), (10, 60),
			cv2.FONT_HERSHEY_SIMPLEX, 0.5, (0, 0, 255), 2)
        #-------------
        if delta_x < 20:
	    #print("CamRight",Xcoor)
            CamRight()
	    time.sleep(0.2)
	#--------------
        if delta_x > 20:
	    #print("CamUp",ycoor)
            CamLeft()
	    time.sleep(0.2)  
	#--------------    
	if delta_y < 10:
	    #print("CamDown",ycoor)
            CamDown()
	    time.sleep(0.2)
	#--------------
        if delta_y > 10:
	    #print("CamLeft",Xcoor)
            CamUp()
	    time.sleep(0.2)     
            
        #cv2.imwrite('/home/pi/QBO/QBO_Test/img_gray.jpg',gray)
        #cv2.imwrite('/home/pi/QBO/QBO_Test/FaceTest.jpg',frame)
        
        #print("FACE counter",counter)
    else:
        facedet = False
	ir+=1
	counter = 0
	ServoHome()
        #print("no face _ir",ir)
        
    #print("delta x", delta_x, " delta y", delta_y)
    #print("contatore",counter)
    cv2.imshow('Video', frame)
    
    if cv2.waitKey(1) & 0xFF == ord('q'):
        break

# When everything is done, release the capture
video_capture.release()
cv2.destroyAllWindows()
QBO.SetNoseColor(0)
time.sleep(0.5)
QBO.SetMouth(0)
